<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html" xmlns:p="http://primefaces.org/ui" xmlns:f="http://java.sun.com/jsf/core">

<h:head>
	<title>Usuarios</title>
</h:head>

<h:body>

	<p:growl id="growl" showDetail="true" showSummary="true" autoUpdate="true" life="6000" escape="false" />

	<h:form id="formUsuarios">

		<p:panel header="Administración de Usuarios">

			<br />

			<p:panelGrid columns="3" id="panelDU">

				<f:facet name="header">Datos del Usuario</f:facet>

				<p:outputLabel value="Nombre" for="nombre" />
				<p:inputText id="nombre" value="#{usuarioMB.usuario.nombre}" required="true"
					requiredMessage="Debe ingresar un Nombre" />
				<p:message for="nombre" />

				<p:outputLabel value="Apellido Paterno" for="apePat" />
				<p:inputText id="apePat" value="#{usuarioMB.usuario.apellidoPaterno}" required="true"
					requiredMessage="Debe ingresar un Apellido Paterno" />
				<p:message for="apePat" />

				<p:outputLabel value="Apellido Materno" for="apeMat" />
				<p:inputText id="apeMat" value="#{usuarioMB.usuario.apellidoMaterno}" />
				<p:message for="apeMat" />

				<p:outputLabel value="Edad" for="edad" />
				<p:inputText id="edad" value="#{usuarioMB.usuario.edad}" />
				<p:message for="edad" />

				<p:outputLabel value="Dirección" for="direccion" />
				<p:inputText id="direccion" value="#{usuarioMB.usuario.direccion}" />
				<p:message for="direccion" />

				<p:outputLabel value="Correo" for="correo" />
				<p:inputText id="correo" value="#{usuarioMB.usuario.correo}" />
				<p:message for="correo" />

			</p:panelGrid>

			<br />

			<p:panelGrid columns="3" id="panelDCU">

				<f:facet name="header">Datos de la Cuenta del Usuario</f:facet>

				<p:outputLabel value="Usuario" for="usuario" />
				<p:inputText id="usuario" value="#{usuarioMB.usuario.usuario}" />
				<p:message for="usuario" />

				<p:outputLabel value="Contraseña" for="pass1" />
				<p:password id="pass1" value="#{usuarioMB.usuario.contrasenia}" match="pass2" feedback="true" redisplay="true"
					strongLabel="Contraseña Fuerte" goodLabel="Contraseña Buena" weakLabel="Contraseña Debil"
					label="Ingresa una contraseña" />
				<p:message for="pass1" />

				<p:outputLabel value="Repetir Contraseña" for="pass2" />
				<p:password id="pass2" value="#{usuarioMB.usuario.contrasenia}" feedback="true" redisplay="true"
					strongLabel="Contraseña Fuerte" goodLabel="Contraseña Buena" weakLabel="Contraseña Debil" />
				<p:message for="pass2" />

				<p:outputLabel value="Rol" for="rol" />
				<p:selectOneMenu id="rol" value="#{usuarioMB.usuario.rol}" converter="#{rolConverter}">
					<f:selectItem itemLabel="Elegir.." itemValue="#{null}" noSelectionOption="true" />
					<f:selectItems value="#{usuarioMB.roles}" var="r" itemLabel="#{r.descripcion}" itemValue="#{r}" />
				</p:selectOneMenu>
				<p:message for="rol" />

			</p:panelGrid>

			<p:commandButton value="Guardar" actionListener="#{usuarioMB.guardar()}" update="@form, tbl">
				<p:confirm header="Confirmación" message="Desea guardar el registro?" icon="ui-icon-alert" />
			</p:commandButton>
			<p:commandButton value="Cancelar" actionListener="#{usuarioMB.cancelar()}" update="@form" process="@this" />

			<br />
			<br />

			<p:contextMenu for="tbl">
				<p:menuitem value="Editar" update="panelDU panelDCU" icon="ui-icon-search"
					actionListener="#{usuarioMB.actualizar()}" process="tbl @this" />
				<p:menuitem value="Eliminar" update="tbl" icon="ui-icon-close" actionListener="#{usuarioMB.eliminar()}"
					process="tbl @this" />
			</p:contextMenu>

			<p:dataTable id="tbl" value="#{usuarioMB.usuarios}" var="u" emptyMessage="Sin registros"
				selection="#{usuarioMB.slcUsuario}" selectionMode="single" rowKey="#{u.id}" rows="10" paginator="true"
				paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
				rowsPerPageTemplate="5,10,15" filteredValue="#{usuarioMB.filtroUsuarios}" widgetVar="tbl">

				<f:facet name="header">Usuarios registrados</f:facet>

				<p:column headerText="ID" style="text-align:center;" filterBy="#{u.id}" filterMatchMode="exact">
					<h:outputText value="#{u.id}" />
				</p:column>

				<p:column headerText="Nombre" style="text-align:center;" filterBy="#{u.nombre}" filterMatchMode="contains">
					<h:outputText value="#{u.nombre} #{u.apellidoPaterno} #{u.apellidoMaterno}" />
				</p:column>

				<p:column headerText="Edad" style="text-align:center;" filterBy="#{u.edad}" filterMatchMode="exact">
					<h:outputText value="#{u.edad}" />
				</p:column>

				<p:column headerText="Correo" style="text-align:center;" filterBy="#{u.correo}" filterMatchMode="contains">
					<h:outputText value="#{u.correo}" />
				</p:column>

				<p:column headerText="Rol" style="text-align:center;" filterBy="#{u.rol}" filterMatchMode="exact">
					<f:facet name="filter">
						<p:selectOneMenu onchange="PF('tbl').filter()">
							<f:selectItem itemLabel="Elegir" itemValue="#{null}" noSelectionOption="true" />
							<f:selectItems value="#{usuarioMB.roles}" var="rl" itemLabel="#{rl.descripcion}" />
						</p:selectOneMenu>
					</f:facet>
					<h:outputText value="#{u.rol.descripcion}" />
				</p:column>

			</p:dataTable>

		</p:panel>

		<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />

	</h:form>

	<h:form>
		<p:commandButton action="#{login.logout}" value="Salir" ajax="false" process="@this" />
		<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />
	</h:form>

	<p:confirmDialog global="true" showEffect="fade" hideEffect="fade">
		<p:commandButton value="Si" type="button" styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
		<p:commandButton value="No" type="button" styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
	</p:confirmDialog>

</h:body>

</html>